
/* 
	Simple TextEntry box

	By Pat Niemeyer (pat@icon-stl.net)
*/

package text;

import awt.*;
import browser.Applet;
import text.*;

public class TextEntry extends TextDisplay {
	int cols, xpad, ypad;
	public int prompt = 0;
	StringBuffer text;
	TextCallBack callback;

	public TextEntry( Applet applet, Font font, int c, int x, int y ) {
		super( applet, font, x, y );
		callback = (TextCallBack)applet;
		cols = c ;
		Width = font.stringWidth(maxwidestring(cols) + "@@");
		xpad = font.stringWidth("@")/2;
		Height = font.actualHeight * 2;
		ypad = font.actualHeight/2;
		text = new StringBuffer();
	}

	public void Prompt( ) {
		Prompt("");
	}

	public void Prompt( String s ) {
		text = new StringBuffer(s);
		prompt = text.length();
		repaint();
	}

	public void paint(Graphics g) {
		drawbox(g);
		clear(g);
		g.setFont(font);
		g.setForeground(Color.black);
		g.drawString(text.toString() + "_", xo + xpad, 
			yo + ypad + (Height/2 - font.actualHeight/2) +2 );
	}

	public void mouseDown( int x, int y ) {
		applet.getFocus();
	}

	public void keyDown(int ch) {
		switch (ch) {
		case (11):	// Ctrl-k
				text.setLength(prompt);
			break;
		case (8):	// delete
				if (text.length() > prompt)
					text.setLength(text.length()-1);
			break;
		case ('\n'):
				callback.EntryLine(text.toString());
				text.setLength(prompt);
			break;
		case ('`'):
				text.appendChar('.');
			break;
		default:
			if ( ch >= ' ' )
				text.appendChar(ch);
		}
	repaint();
	}
}
