
/* 
	A Simple text notice class which auto-centers and can put
	up a little text based wait spinner.

	by Pat Niemeyer (pat@icon-stl.net)
*/

package text;

import awt.*;
import text.*;

class TextNotice extends Display {
	String text;
	TextDisplay tdisp;
	Color color = Color.red;
	public int X, Y, height, width;
	TextSpinner spinner;

	TextNotice ( TextDisplay td, String s ) {
		super(td.applet);
		tdisp = td;
		text = s;
		height = tdisp.font.actualHeight;
		width = tdisp.font.stringWidth(text);
		X = tdisp.xo + tdisp.Width/2-width/2;
		Y = tdisp.yo + tdisp.Height/2-height/2;
	}

	public void start_spinner() {
		if ( spinner == null ) {
			spinner = new TextSpinner ( (Display)this, 
				tdisp.font, X + width + 4 , Y );
		}
		spinner.start();
	}

	public void stop_spinner() {
		if ( spinner != null )
			spinner.stop();
	}

	// I have children so I have to catch update
	public void update(Graphics g) {
		super.update(g);
		if ( spinner != null )
			spinner.update(g);
	}

	public void paint(Graphics g) {
		g.setFont(tdisp.font);
		g.setForeground(color);
		tdisp.clear(g);
		g.drawString(text, X, Y);
		if ( spinner != null )
			spinner.paint(g);
	}

}
